
/*  A Bison parser, made from msql_yac.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */


/*---| prototypes |---*/
extern alloca();
void yyerror();

#define	END_OF_INPUT	258
#define	GE	259
#define	LE	260
#define	NE	261
#define	EQ	262
#define	GT	263
#define	LT	264
#define	CREATE	265
#define	DROP	266
#define	INSERT	267
#define	DELETE	268
#define	SELECT	269
#define	UPDATE	270
#define	ALL	271
#define	DISTINCT	272
#define	AS	273
#define	WHERE	274
#define	ORDER	275
#define	FROM	276
#define	INTO	277
#define	TABLE	278
#define	BY	279
#define	ASC	280
#define	DESC	281
#define	LIKE	282
#define	AND	283
#define	OR	284
#define	VALUES	285
#define	SET	286
#define	NOT	287
#define	NULLSYM	288
#define	PRIMARY	289
#define	KEY	290
#define	IDENT	291
#define	TEXT	292
#define	NUM	293
#define	REAL_NUM	294
#define	INT_	295
#define	BOOL_	296
#define	CHAR_	297
#define	REAL_	298
#define	LIMIT	299
#define	SYSDATE	300
#define	SYSTIME	301

#line 22 "msql_yac.y"

#include <stdio.h>
#include <sys/types.h>

#include <sys/socket.h>
#include <netinet/in.h>
#ifdef OS2
#  undef  APIENTRY
#  define APIENTRY _Optlink
#  include <arpa/nameser.h>
#else
#  include <arpa/inet.h>
#endif
#include <signal.h>
#include <netdb.h>

#include <time.h>                                          /* OS/2 !!! */

#include "common/portable.h"
#include "msql_prv.h"
#include "msql.h"

int     yylineno;
extern  int selectWildcard,
        selectDistinct,
        yytoklen;
ident_t *msqlCreateIdent();

#define myFree(x) Free(x,__FILE__,__LINE__)


#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		139
#define	YYFLAG		-32768
#define	YYNTBASE	52

#define YYTRANSLATE(x) ((unsigned)(x) <= 301 ? yytranslate[x] : 87)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    47,
    48,    50,     2,    49,     2,    51,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     6,     8,    10,    12,    14,    16,    17,
    25,    27,    31,    36,    38,    40,    45,    46,    49,    50,
    53,    62,    63,    65,    67,    71,    73,    75,    77,    79,
    83,    87,    93,    94,    96,    98,    99,   102,   108,   112,
   114,   116,   118,   120,   122,   124,   126,   128,   130,   133,
   134,   138,   143,   146,   148,   150,   151,   152,   155,   159,
   160,   170,   171,   175,   179,   181,   185,   187,   193,   199,
   203,   208,   210,   212,   214,   216,   218,   220,   222,   224,
   226
};

static const short yyrhs[] = {    -1,
    53,     3,     0,    54,     0,    61,     0,    75,     0,    76,
     0,    81,     0,    83,     0,     0,    10,    23,    36,    47,
    55,    56,    48,     0,    57,     0,    56,    49,    57,     0,
    86,    58,    59,    60,     0,    40,     0,    43,     0,    42,
    47,    38,    48,     0,     0,    32,    33,     0,     0,    34,
    35,     0,    14,    62,    63,    21,    65,    67,    71,    74,
     0,     0,    16,     0,    17,     0,    63,    49,    64,     0,
    64,     0,    50,     0,    86,     0,    36,     0,    36,    66,
    36,     0,    65,    49,    36,     0,    65,    49,    36,    66,
    36,     0,     0,    18,     0,     7,     0,     0,    19,    68,
     0,    68,    69,    86,    70,    85,     0,    86,    70,    85,
     0,    28,     0,    29,     0,     7,     0,     6,     0,     9,
     0,     5,     0,     8,     0,     4,     0,    27,     0,    32,
    27,     0,     0,    20,    24,    72,     0,    72,    49,    86,
    73,     0,    86,    73,     0,    25,     0,    26,     0,     0,
     0,    44,    84,     0,    11,    23,    36,     0,     0,    12,
    22,    36,    78,    77,    30,    47,    80,    48,     0,     0,
    47,    79,    48,     0,    79,    49,    86,     0,    86,     0,
    80,    49,    84,     0,    84,     0,    15,    36,    31,    82,
    67,     0,    82,    49,    86,     7,    84,     0,    86,     7,
    84,     0,    13,    21,    36,    67,     0,    37,     0,    38,
     0,    39,     0,    33,     0,    45,     0,    46,     0,    84,
     0,    86,     0,    36,     0,    36,    51,    36,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   124,   125,   132,   133,   134,   135,   136,   137,   146,   157,
   161,   162,   167,   184,   185,   186,   193,   197,   204,   208,
   222,   228,   230,   232,   236,   237,   238,   252,   262,   272,
   284,   294,   308,   309,   310,   313,   314,   318,   326,   337,
   339,   343,   345,   347,   349,   351,   353,   355,   357,   362,
   363,   366,   370,   376,   377,   378,   382,   384,   393,   411,
   424,   428,   440,   447,   455,   467,   471,   483,   495,   504,
   520,   538,   543,   548,   553,   557,   575,   595,   599,   606,
   616
};

static const char * const yytname[] = {   "$","error","$illegal.","END_OF_INPUT",
"GE","LE","NE","EQ","GT","LT","CREATE","DROP","INSERT","DELETE","SELECT","UPDATE",
"ALL","DISTINCT","AS","WHERE","ORDER","FROM","INTO","TABLE","BY","ASC","DESC",
"LIKE","AND","OR","VALUES","SET","NOT","NULLSYM","PRIMARY","KEY","IDENT","TEXT",
"NUM","REAL_NUM","INT_","BOOL_","CHAR_","REAL_","LIMIT","SYSDATE","SYSTIME",
"'('","')'","','","'*'","'.'","query","verb_clause","create","@1","field_list",
"field_list_item","type","opt_nullspec","opt_keyspec","select","dist_qual","item_list",
"field","table_list","table_alias","where_clause","cond_list","cond_cont","cond_op",
"order_clause","order_list","order_dir","limit_clause","drop","insert","@2",
"opt_field_spec","fields","values","update","update_list","delete","literal",
"cond_literal","qual_ident",""
};
#endif

static const short yyr1[] = {     0,
    52,    52,    53,    53,    53,    53,    53,    53,    55,    54,
    56,    56,    57,    58,    58,    58,    59,    59,    60,    60,
    61,    62,    62,    62,    63,    63,    63,    64,    65,    65,
    65,    65,    66,    66,    66,    67,    67,    68,    68,    69,
    69,    70,    70,    70,    70,    70,    70,    70,    70,    71,
    71,    72,    72,    73,    73,    73,    74,    74,    75,    77,
    76,    78,    78,    79,    79,    80,    80,    81,    82,    82,
    83,    84,    84,    84,    84,    84,    84,    85,    85,    86,
    86
};

static const short yyr2[] = {     0,
     0,     2,     1,     1,     1,     1,     1,     1,     0,     7,
     1,     3,     4,     1,     1,     4,     0,     2,     0,     2,
     8,     0,     1,     1,     3,     1,     1,     1,     1,     3,
     3,     5,     0,     1,     1,     0,     2,     5,     3,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     2,     0,
     3,     4,     2,     1,     1,     0,     0,     2,     3,     0,
     9,     0,     3,     3,     1,     3,     1,     5,     5,     3,
     4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     3
};

static const short yydefact[] = {     1,
     0,     0,     0,     0,    22,     0,     0,     3,     4,     5,
     6,     7,     8,     0,     0,     0,     0,    23,    24,     0,
     0,     2,     0,    59,    62,    36,    80,    27,     0,    26,
    28,     0,     9,     0,    60,     0,    71,     0,     0,     0,
    36,     0,     0,     0,    65,     0,    37,     0,    81,    29,
    36,    25,     0,    68,     0,     0,    11,     0,    63,     0,
     0,    40,    41,     0,    47,    45,    43,    42,    46,    44,
    48,     0,     0,    35,    34,     0,     0,    50,     0,    75,
    72,    73,    74,    76,    77,    70,    10,     0,    14,     0,
    15,    17,    64,     0,     0,    49,    78,    39,    79,    30,
    31,     0,    57,     0,    12,     0,     0,    19,     0,    67,
     0,     0,     0,     0,    21,    69,     0,    18,     0,    13,
    61,     0,    38,    32,    51,    56,    58,    16,    20,    66,
     0,    54,    55,    53,    56,    52,     0,     0,     0
};

static const short yydefgoto[] = {   137,
     7,     8,    43,    56,    57,    92,   108,   120,     9,    20,
    29,    30,    51,    76,    37,    47,    64,    73,   103,   125,
   134,   115,    10,    11,    46,    35,    44,   109,    12,    41,
    13,    97,    98,    31
};

static const short yypact[] = {     2,
    -4,    28,   -13,    18,     7,    12,    56,-32768,-32768,-32768,
-32768,-32768,-32768,    27,    33,    41,    42,-32768,-32768,   -28,
    49,-32768,    35,-32768,    36,    65,    34,-32768,   -15,-32768,
-32768,    51,-32768,    51,-32768,    51,-32768,    52,    53,    51,
   -16,    79,    51,   -22,-32768,    60,    29,    38,-32768,     0,
   -14,-32768,    51,-32768,    -8,    23,-32768,    24,-32768,    51,
    44,-32768,-32768,    51,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    66,    16,-32768,-32768,    58,    59,    72,    89,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    51,-32768,    54,
-32768,    68,-32768,    -8,    38,-32768,-32768,-32768,-32768,-32768,
     0,    73,    61,    -8,-32768,    64,    70,    74,    25,-32768,
    16,    62,    51,    -8,-32768,-32768,    63,-32768,    69,-32768,
-32768,    -8,-32768,-32768,    57,    50,-32768,-32768,-32768,-32768,
    51,-32768,-32768,-32768,    50,-32768,   107,   109,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,    22,-32768,-32768,-32768,-32768,-32768,
-32768,    75,-32768,    11,   -31,-32768,-32768,    19,-32768,-32768,
   -19,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -54,     6,   -32
};


#define	YYLAST		117


static const short yytable[] = {    42,
    86,    45,    36,    48,    36,    39,    74,    27,    16,    54,
    58,     1,     2,     3,     4,     5,     6,    75,    14,    78,
    79,    28,    18,    19,    80,    59,    60,    93,    81,    82,
    83,    95,    53,    40,    77,   -33,    84,    85,    17,   110,
    99,    65,    66,    67,    68,    69,    70,    21,    80,   116,
    15,    27,    81,    82,    83,    58,    62,    63,    22,   127,
    84,    85,    23,    89,    71,    90,    91,   130,    24,    72,
    87,    88,   121,   122,   132,   133,    25,    26,    99,    32,
   126,    33,    34,    36,    38,    55,    27,    49,    50,    61,
    94,   102,    96,   100,   101,   104,   113,   124,   135,   107,
   106,   117,   118,   129,   114,   131,   138,   119,   139,   105,
   128,   112,     0,   111,    52,   136,   123
};

static const short yycheck[] = {    32,
    55,    34,    19,    36,    19,    21,     7,    36,    22,    41,
    43,    10,    11,    12,    13,    14,    15,    18,    23,    51,
    53,    50,    16,    17,    33,    48,    49,    60,    37,    38,
    39,    64,    49,    49,    49,    36,    45,    46,    21,    94,
    73,     4,     5,     6,     7,     8,     9,    36,    33,   104,
    23,    36,    37,    38,    39,    88,    28,    29,     3,   114,
    45,    46,    36,    40,    27,    42,    43,   122,    36,    32,
    48,    49,    48,    49,    25,    26,    36,    36,   111,    31,
   113,    47,    47,    19,    51,     7,    36,    36,    36,    30,
    47,    20,    27,    36,    36,     7,    24,    36,   131,    32,
    47,    38,    33,    35,    44,    49,     0,    34,     0,    88,
    48,   101,    -1,    95,    40,   135,   111
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/sprachen/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         -2
#define YYEOF           0
#define YYACCEPT        return(0)
#define YYABORT         return(1)
#define YYERROR         goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL          goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do                                                              \
  if (yychar == YYEMPTY && yylen == 1)                          \
    { yychar = (token), yylval = (value);                       \
      yychar1 = YYTRANSLATE (yychar);                           \
      YYPOPSTACK;                                               \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    { yyerror ("syntax error: cannot back up"); YYERROR; }      \
while (0)

#define YYTERROR        1
#define YYERRCODE       256

#ifndef YYPURE
#define YYLEX           yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX           yylex(&yylval, &yylloc)
#else
#define YYLEX           yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int     yychar;                 /*  the lookahead symbol                */
YYSTYPE yylval;                 /*  the semantic value of the           */
                                /*  lookahead symbol                    */

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;                 /*  location data for the lookahead     */
                                /*  symbol                              */
#endif

int yynerrs;                    /*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;                    /*  nonzero means print parse trace     */
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks       */

#ifndef YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1                /* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)       __builtin_memcpy(TO,FROM,COUNT)
#else                           /* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/sprachen/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;      /*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;              /*  lookahead token as an internal (translated) token number */

  short yyssa[YYINITDEPTH];     /*  the state stack                     */
  YYSTYPE yyvsa[YYINITDEPTH];   /*  the semantic value stack            */

  short *yyss = yyssa;          /*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;        /*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];   /*  the location stack                  */
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;                /*  the variable used to return         */
                                /*  semantic values from the action     */
                                /*  routines                            */

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;             /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
         the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
         but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
                 &yyss1, size * sizeof (*yyssp),
                 &yyvs1, size * sizeof (*yyvsp),
                 &yyls1, size * sizeof (*yylsp),
                 &yystacksize);
#else
      yyoverflow("parser stack overflow",
                 &yyss1, size * sizeof (*yyssp),
                 &yyvs1, size * sizeof (*yyvsp),
                 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
        {
          yyerror("parser stack overflow");
          return 2;
        }
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
        yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
        fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
        YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
        fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)              /* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;           /* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
        fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
        {
          fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
          /* Give the individual parser a way to print the precise meaning
             of a token, for further debugging info.  */
#ifdef YYPRINT
          YYPRINT (stderr, yychar, yylval);
#endif
          fprintf (stderr, ")\n");
        }
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
               yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
        fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 126 "msql_yac.y"
{
                        msqlProcessQuery();
                        msqlClean();
                ;
    break;}
case 9:
#line 147 "msql_yac.y"
{
                        command = CREATE;
                        if (msqlAddTable(yyvsp[-1],NULL) < 0)
                        {
                                myFree(yyvsp[-1]);
                                msqlClean();
                                return;
                        }
                        myFree(yyvsp[-1]);
                ;
    break;}
case 13:
#line 168 "msql_yac.y"
{
                        if(msqlAddField(yyvsp[-3],yyvsp[-2],arrayLen,notnullflag,keyflag)<0)
                        {
                                msqlClean();
                                return;
                        }
                        if (arrayLen)
                        {
                                (void)myFree(arrayLen);
                        }
                        arrayLen = 0;
                ;
    break;}
case 16:
#line 187 "msql_yac.y"
{
                        arrayLen = yyvsp[-1];
                        yyval=yyvsp[-3];
                ;
    break;}
case 17:
#line 194 "msql_yac.y"
{
                        notnullflag = 0;
                ;
    break;}
case 18:
#line 198 "msql_yac.y"
{
                        notnullflag = 1;
                ;
    break;}
case 19:
#line 205 "msql_yac.y"
{
                        keyflag = 0;
                ;
    break;}
case 20:
#line 209 "msql_yac.y"
{
                        keyflag = 1;
                ;
    break;}
case 21:
#line 223 "msql_yac.y"
{
                        command = SELECT;
                ;
    break;}
case 22:
#line 229 "msql_yac.y"
{ selectDistinct = 0; ;
    break;}
case 23:
#line 231 "msql_yac.y"
{ selectDistinct = 0; ;
    break;}
case 24:
#line 233 "msql_yac.y"
{ selectDistinct = 1; ;
    break;}
case 27:
#line 239 "msql_yac.y"
{
                        ident_t *tmp;

                        tmp = msqlCreateIdent(NULL,"*");
                        if (msqlAddField(tmp,0,0,0,0) < 0)
                        {
                                msqlClean();
                                return;
                        }
                        selectWildcard = 1;
                ;
    break;}
case 28:
#line 253 "msql_yac.y"
{
                        if (msqlAddField(yyvsp[0],0,0,0,0) < 0)
                        {
                                msqlClean();
                                return;
                        }
                ;
    break;}
case 29:
#line 263 "msql_yac.y"
{
                        if (msqlAddTable(yyvsp[0],NULL) < 0)
                        {
                                myFree(yyvsp[0]);
                                msqlClean();
                                return;
                        }
                        myFree(yyvsp[0]);
                ;
    break;}
case 30:
#line 273 "msql_yac.y"
{
                        if (msqlAddTable(yyvsp[-2], yyvsp[0]) < 0)
                        {
                                myFree(yyvsp[-2]);
                                myFree(yyvsp[0]);
                                msqlClean();
                                return;
                        }
                        myFree(yyvsp[-2]);
                        myFree(yyvsp[0]);
                ;
    break;}
case 31:
#line 285 "msql_yac.y"
{
                        if (msqlAddTable(yyvsp[0],NULL) < 0)
                        {
                                myFree(yyvsp[0]);
                                msqlClean();
                                return;
                        }
                        myFree(yyvsp[0]);
                ;
    break;}
case 32:
#line 295 "msql_yac.y"
{
                        if (msqlAddTable(yyvsp[-2], yyvsp[0]) < 0)
                        {
                                myFree(yyvsp[-2]);
                                myFree(yyvsp[0]);
                                msqlClean();
                                return;
                        }
                        myFree(yyvsp[-2]);
                        myFree(yyvsp[0]);
                ;
    break;}
case 38:
#line 319 "msql_yac.y"
{
                        if (msqlAddCond(yyvsp[-2],yyvsp[-1],yyvsp[0],yyvsp[-3]) < 0)
                        {
                                msqlClean();
                                return;
                        }
                ;
    break;}
case 39:
#line 327 "msql_yac.y"
{
                        if (msqlAddCond(yyvsp[-2],yyvsp[-1],yyvsp[0],NO_BOOL) < 0)
                        {
                                msqlClean();
                                return;
                        }
                ;
    break;}
case 40:
#line 338 "msql_yac.y"
{ yyval = (char *)AND_BOOL; ;
    break;}
case 41:
#line 340 "msql_yac.y"
{ yyval = (char *)OR_BOOL; ;
    break;}
case 42:
#line 344 "msql_yac.y"
{ yyval = (char *)EQ_OP; ;
    break;}
case 43:
#line 346 "msql_yac.y"
{ yyval = (char *)NE_OP; ;
    break;}
case 44:
#line 348 "msql_yac.y"
{ yyval = (char *)LT_OP; ;
    break;}
case 45:
#line 350 "msql_yac.y"
{ yyval = (char *)LE_OP; ;
    break;}
case 46:
#line 352 "msql_yac.y"
{ yyval = (char *)GT_OP; ;
    break;}
case 47:
#line 354 "msql_yac.y"
{ yyval = (char *)GE_OP; ;
    break;}
case 48:
#line 356 "msql_yac.y"
{ yyval = (char *)LIKE_OP; ;
    break;}
case 49:
#line 358 "msql_yac.y"
{ yyval = (char *)NOT_LIKE_OP; ;
    break;}
case 52:
#line 367 "msql_yac.y"
{
                        msqlAddOrder(yyvsp[-1],(int) yyvsp[0]);
                ;
    break;}
case 53:
#line 371 "msql_yac.y"
{
                        msqlAddOrder(yyvsp[-1],(int) yyvsp[0]);
                ;
    break;}
case 56:
#line 379 "msql_yac.y"
{ yyval = (char *) ASC; ;
    break;}
case 57:
#line 383 "msql_yac.y"
{ msqlSelectLimit = 0; ;
    break;}
case 58:
#line 385 "msql_yac.y"
{ msqlSetSelectLimit(yyvsp[0]); ;
    break;}
case 59:
#line 394 "msql_yac.y"
{
                        command = DROP;
                        if (msqlAddTable(yyvsp[0],NULL) < 0)
                        {
                                myFree(yyvsp[0]);
                                msqlClean();
                                return;
                        }
                        myFree(yyvsp[0]);
                ;
    break;}
case 60:
#line 412 "msql_yac.y"
{
                        command = INSERT;
                        if (msqlAddTable(yyvsp[-1],NULL) < 0)
                        {
                                msqlClean();
                                myFree(yyvsp[-1]);
                                return;
                        }
                        if (yyvsp[0])
                                expandTableFields(yyvsp[-1]);
                        myFree(yyvsp[-1]);
                ;
    break;}
case 62:
#line 429 "msql_yac.y"
{
                        ident_t *tmp;

                        tmp = msqlCreateIdent(NULL,"*");
                        if (msqlAddField(tmp,0,0,0,0) < 0)
                        {
                                msqlClean();
                                return;
                        }
                        yyval = (char *) 1;
                ;
    break;}
case 63:
#line 441 "msql_yac.y"
{
                        yyval = (char *) 0;
                ;
    break;}
case 64:
#line 448 "msql_yac.y"
{
                        if (msqlAddField(yyvsp[0],0,0,0,0) < 0)
                        {
                                msqlClean();
                                return;
                        }
                ;
    break;}
case 65:
#line 456 "msql_yac.y"
{
                        if (msqlAddField(yyvsp[0],0,0,0,0) < 0)
                        {
                                msqlClean();
                                return;
                        }
                ;
    break;}
case 66:
#line 468 "msql_yac.y"
{
                        msqlAddFieldValue(yyvsp[0]);
                 ;
    break;}
case 67:
#line 472 "msql_yac.y"
{
                        msqlAddFieldValue(yyvsp[0]);
                ;
    break;}
case 68:
#line 484 "msql_yac.y"
{
                        command = UPDATE;
                        if (msqlAddTable(yyvsp[-3],NULL) < 0)
                        {
                                msqlClean();
                                return;
                        }
                        myFree(yyvsp[-3]);
                ;
    break;}
case 69:
#line 496 "msql_yac.y"
{
                        if (msqlAddField(yyvsp[-2],0,0,0,0) < 0)
                        {
                                msqlClean();
                                return;
                        }
                        msqlAddFieldValue(yyvsp[0]);
                ;
    break;}
case 70:
#line 505 "msql_yac.y"
{
                        if (msqlAddField(yyvsp[-2],0,0,0,0) < 0)
                        {
                                msqlClean();
                                return;
                        }
                        msqlAddFieldValue(yyvsp[0]);
                ;
    break;}
case 71:
#line 521 "msql_yac.y"
{
                        command = DELETE;
                        if (msqlAddTable(yyvsp[-1],NULL) < 0)
                        {
                                myFree(yyvsp[-1]);
                                msqlClean();
                                return;
                        }
                        myFree(yyvsp[-1]);
                ;
    break;}
case 72:
#line 539 "msql_yac.y"
{
                        yyval = (char *)msqlCreateValue(yyvsp[0],CHAR_TYPE,yytoklen);
                        (void)myFree(yyvsp[0]);
                ;
    break;}
case 73:
#line 544 "msql_yac.y"
{
                        yyval = (char *)msqlCreateValue(yyvsp[0],INT_TYPE,0);
                        (void)myFree(yyvsp[0]);
                ;
    break;}
case 74:
#line 549 "msql_yac.y"
{
                        yyval = (char *)msqlCreateValue(yyvsp[0],REAL_TYPE,0);
                        (void)myFree(yyvsp[0]);
                ;
    break;}
case 75:
#line 554 "msql_yac.y"
{
                        yyval = (char *)msqlCreateValue("null",NULL_TYPE,0);
                ;
    break;}
case 76:
#line 558 "msql_yac.y"
{
                        char           *pszDate = " 1970/01/01";
                        struct tm      *psDateTime;
                        time_t          lTime;
                        time( &lTime );
                        psDateTime = localtime( &lTime );
                        sprintf( pszDate,
                                 " %4d/%02d/%2d",
                                 1900 + psDateTime->tm_year,
                                 1 + psDateTime->tm_mon,
                                 psDateTime->tm_mday
                               );
                        yyval = (char *)msqlCreateValue( pszDate,
                                                      CHAR_TYPE,
                                                      12
                                                    );
                ;
    break;}
case 77:
#line 576 "msql_yac.y"
{
                        char           *pszTime = " 00:00.00";
                        struct tm      *psDateTime;
                        time_t          lTime;
                        time( &lTime );
                        psDateTime = localtime( &lTime );
                        sprintf( pszTime,
                                 " %2d:%02d.%2d",
                                 psDateTime->tm_hour,
                                 psDateTime->tm_min,
                                 psDateTime->tm_sec
                               );
                        yyval = (char *)msqlCreateValue( pszTime,
                                                      CHAR_TYPE,
                                                      10
                                                    );
                ;
    break;}
case 78:
#line 596 "msql_yac.y"
{
                        yyval = yyvsp[0];
                ;
    break;}
case 79:
#line 600 "msql_yac.y"
{
                        yyval = (char *)msqlCreateValue(yyvsp[0],IDENT_TYPE);
                ;
    break;}
case 80:
#line 607 "msql_yac.y"
{
                        yyval = (char *)msqlCreateIdent(NULL,yyvsp[0]);
                        (void)myFree(yyvsp[0]);
                        if (yyval == NULL)
                        {
                                msqlClean();
                                return;
                        }
                ;
    break;}
case 81:
#line 617 "msql_yac.y"
{
                        yyval = (char *)msqlCreateIdent(yyvsp[-2],yyvsp[0]);
                        (void)myFree(yyvsp[-2]);
                        (void)myFree(yyvsp[0]);
                        if (yyval == NULL)
                        {
                                msqlClean();
                                return;
                        }
                ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/sprachen/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
        fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
        {
          int size = 0;
          char *msg;
          int x, count;

          count = 0;
          /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
          for (x = (yyn < 0 ? -yyn : 0);
               x < (sizeof(yytname) / sizeof(char *)); x++)
            if (yycheck[x + yyn] == x)
              size += strlen(yytname[x]) + 15, count++;
          msg = (char *) malloc(size + 15);
          if (msg != 0)
            {
              strcpy(msg, "parse error");

              if (count < 5)
                {
                  count = 0;
                  for (x = (yyn < 0 ? -yyn : 0);
                       x < (sizeof(yytname) / sizeof(char *)); x++)
                    if (yycheck[x + yyn] == x)
                      {
                        strcat(msg, count == 0 ? ", expecting `" : " or `");
                        strcat(msg, yytname[x]);
                        strcat(msg, "'");
                        count++;
                      }
                }
              yyerror(msg);
              free(msg);
            }
          else
            yyerror ("parse error; also virtual memory exceeded");
        }
      else
#endif /* YYERROR_VERBOSE */
        yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
        YYABORT;

#if YYDEBUG != 0
      if (yydebug)
        fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;              /* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
        fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
        goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 627 "msql_yac.y"
